=== debian/changelog ===
sundials (3.1.2+dfsg-3ubuntu2) focal; urgency=medium

  * Use python2 more

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 09 Apr 2020 08:10:24 +0000

sundials (3.1.2+dfsg-3ubuntu1) focal; urgency=medium

  * Use python2.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 01 Apr 2020 19:00:51 +0100

sundials (3.1.2+dfsg-3build5) focal; urgency=medium

  * No-change rebuild against libpetsc-real3.12

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 04 Jan 2020 18:27:24 +0000

sundials (3.1.2+dfsg-3build4) focal; urgency=medium

  * No-change rebuild against hypre 2.18.2

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 13 Nov 2019 09:13:21 +0000

sundials (3.1.2+dfsg-3build3) eoan; urgency=medium

  * Rebuild against new petsc 3.11.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 05 Aug 2019 08:18:26 +0200

sundials (3.1.2+dfsg-3build2) eoan; urgency=medium

  * Rebuild against new hypre 2.16.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Jul 2019 16:56:30 +0200

sundials (3.1.2+dfsg-3build1) disco; urgency=medium

  * No-change rebuild for PETSc/SLEPc 3.10 transition

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 21 Dec 2018 07:17:24 +0000

sundials (3.1.2+dfsg-3) unstable; urgency=medium

  * Team upload
  * Adapt for change in Hypre packaging
    - there is now a single library: libHYPRE_core
    - Build-Depends on libhypre-dev >= 2.15.1-1exp1~

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 30 Nov 2018 11:01:47 +0100

sundials (3.1.2+dfsg-2) unstable; urgency=medium

  * Team upload
  * test-sunmatrix-sparse-tolerance.patch: new patch, should fix FTBFS on
    several arches

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 21 Nov 2018 11:31:14 +0100

sundials (3.1.2+dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Fix installation of READMEs by renaming them. They were all copied to the
    same location, hence overwriting each other
  * Add Build-Depends-Package fields in symbols files
  * Do not install extra license file under /usr/include/sundials/
  * Add lintian override for
    override_dh_auto_test-does-not-check-DEB_BUILD_OPTIONS
  * Add Rules-Requires-Root: no
  * Bump Standards-Version to 4.2.1
  * Bump to debhelper compat level 11

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 20 Nov 2018 12:58:08 +0100
